#include "testlib.h"
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <cassert>
#include <ctime>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

struct Test {
    int n, m;
    vector <pair <int, int> > edges;

    void print(int offset) {
        for (int i = 0; i < m; i++) {
            if (rnd.next(0, 1))
                swap(edges[i].fs, edges[i].sc);
            printf("%d %d\n", edges[i].fs + offset, edges[i].sc + offset);
        }
    }
};

int main(int argc, char ** argv) {
    registerGen(argc, argv, 1);
    if (argc != 9) {
        cerr << "Usage: totn, totm, minn, maxn, minm, maxm, maxt, seed" << endl;

        return 1;
    }

    int totn = atoi(argv[1]);
    int totm = atoi(argv[2]);
    int minn = atoi(argv[3]);
    int maxn = atoi(argv[4]);
    int minm = atoi(argv[5]);
    int maxm = atoi(argv[6]);
    int maxt = atoi(argv[7]);

    vector <Test> tests;
    while (true) {
        int n = rnd.next(minn, maxn);
        int m = rnd.next(minm, maxm);
        m = min(m + 0ll, n * 1ll * (n - 1) / 2);
        if (n > totn || m > totm || (int) tests.size() == maxt)
            break;

        totn -= n;
        totm -= m;

        Test nt;
        nt.n = n;
        nt.m = m;
        set <pair <int, int> > eset;
        while ((int) eset.size() < m) {
            int u = rnd.next(1, n);
            int v = rnd.next(1, n);
            if (u == v)
                continue;
            if (u > v)
                swap(u, v);
            if (eset.count(mp(u, v)) == 0) {
                eset.insert(mp(u, v));
                nt.edges.pb(mp(u, v));                
            }
        }

        tests.pb(nt);
    }

    int sumn = 1 - int(tests.size());
    int summ = 0;
    for (const auto& t : tests) {
        sumn += t.n;
        summ += t.m;
    }

    printf("%d %d\n", sumn, summ);

    int offset = 0;
    for (auto& t : tests) {
        t.print(offset);
        offset += t.n - 1;
    }

    return 0;
}
