#include "testlib.h"
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <cassert>
#include <ctime>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

struct Test {
    int n, m;
    vector <pair <int, int> > edges;

    void print() {
        printf("%d %d\n", n, m);
        for (int i = 0; i < m; i++) {
            if (rnd.next(0, 1))
                swap(edges[i].fs, edges[i].sc);
            printf("%d %d\n", edges[i].fs, edges[i].sc);
        }
    }
};

int main(int argc, char ** argv) {
    registerGen(argc, argv, 1);

    int minn = atoi(argv[1]);
    int maxn = atoi(argv[2]);
    int minm = atoi(argv[3]);
    int maxm = atoi(argv[4]);

    vector <Test> tests;
    int n = rnd.next(minn, maxn);
    int m = rnd.next(minm, maxm);
    m = min(m + 0ll, n * 1ll * (n - 1) / 2);

    Test nt;
    nt.n = n;
    nt.m = m;
    set <pair <int, int> > eset;
    while ((int) eset.size() < m) {
        int u = rnd.next(1, n);
        int v = rnd.next(1, n);
        if (u == v)
            continue;
        if (u > v)
            swap(u, v);
        if (eset.count(mp(u, v)) == 0) {
            eset.insert(mp(u, v));
            nt.edges.pb(mp(u, v));                
        }
    }

    tests.pb(nt);

    for (auto& t : tests) {
        t.print();
    }

    return 0;
}
