#include "testlib.h"
#include <bits/stdc++.h>

constexpr int MAXN[] = {10, 10, 1000, 50 * 1000, 500 * 1000};
constexpr int MAXM[] = {10, 10, 1000, 50 * 1000, 1000 * 1000};

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    int group = atoi(validator.group().c_str());

    int n = inf.readInt(2, MAXN[group], "n");
    inf.readSpace();
    int m = inf.readInt(0, MAXM[group], "m");
    inf.readEoln();

    std::set<std::pair<int, int> > edges;
    for (int i = 0; i < m; i++) {
        int u = inf.readInt(1, n, "u[" + vtos(i) + "]");
        inf.readSpace();
        int v = inf.readInt(1, n, "v[" + vtos(i) + "]");
        inf.readEoln();

        ensuref(u != v, "Graph can't contain loops");
        ensuref(!edges.count(std::make_pair(u, v)) && !edges.count(std::make_pair(v, u)), "Graph can't contain multiple edges");
        edges.emplace(u, v);
    }

    inf.readEof();
    return 0;
}

