#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <cassert>
#include <ctime>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

const int MX = 1000 * 1000;

int tc;
int n, m;
int u[MX], v[MX], d[2][MX];
vector <int> vertex[MX];

void bfs(int tp, int v) {
    for (int i = 0; i < n; i++)
        d[tp][i] = -1;
    d[tp][v] = 0;
    queue <int> q;
    q.push(v);
    while (!q.empty()) {
        int u = q.front();
        q.pop();
        for (auto& w : vertex[u]) {
            if (d[tp][w] == -1) {
                d[tp][w] = d[tp][u] + 1;
                q.push(w);
            }
        }
    }
}

void dfs(int v) {
    for (auto& u : vertex[v]) {
        if (d[0][u] > d[0][v]) {
            d[0][u] = d[0][v];
            dfs(u);
        }
    }
}

int main () {
    tc = 1;
    
    for (int tnum = 0; tnum < tc; tnum++) {
        scanf("%d%d", &n, &m);
        for (int i = 0; i < m; i++) {
            scanf("%d%d", &u[i], &v[i]);
            u[i]--, v[i]--;
        }
        for (int i = 0; i < n; i++)
            vertex[i].clear();
        for (int i = 0; i < m; i++) {
            vertex[u[i]].pb(v[i]);
            vertex[v[i]].pb(u[i]);        
        }
        bfs(0, 0);
        bfs(1, n - 1); 
        vector <pair <int, int> > best;
        for (int i = 0; i < n; i++)
            if (d[0][i] != -1) {
                best.pb(mp(d[0][i], i));
            }
        sort(best.begin(), best.end());
        for (int i = 0; i < n; i++)
            vertex[i].clear();
        for (int i = 0; i < m; i++)
            vertex[u[i]].pb(v[i]);

        for (auto& e : best) {
            dfs(e.sc);
        }

        int ans = n + 1;
        for (int i = 0; i < n; i++)
            if (d[0][i] != -1 && d[1][i] != -1) {
                ans = min(ans, d[0][i] + d[1][i]);
            }

        printf("%d\n", (ans == n + 1 ? -1 : ans));
    }

    return 0;
}
