// 2018, Sayutin Dmitry.

#include "testlib.h"
#include <bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;

using std::vector;
using std::map;
using std::array;
using std::set;
using std::string;

using std::pair;
using std::make_pair;

using std::tuple;
using std::make_tuple;
using std::get;

using std::min;
using std::abs;
using std::max;
using std::swap;

using std::unique;
using std::sort;
using std::generate;
using std::reverse;
using std::min_element;
using std::max_element;

#ifdef LOCAL
#define LASSERT(X) assert(X)
#else
#define LASSERT(X) {}
#endif

template <typename T>
T input() {
    T res;
    cin >> res;
    LASSERT(cin);
    return res;
}

template <typename IT>
void input_seq(IT b, IT e) {
    std::generate(b, e, input<typename std::remove_reference<decltype(*b)>::type>);
}

#define SZ(vec)         int((vec).size())
#define ALL(data)       data.begin(),data.end()
#define RALL(data)      data.rbegin(),data.rend()
#define TYPEMAX(type)   std::numeric_limits<type>::max()
#define TYPEMIN(type)   std::numeric_limits<type>::min()

int main(int argc, char** argv) {
    std::iostream::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    // code here
    registerGen(argc, argv, 1);
    int n = atoi(argv[1]);
    int k = atoi(argv[2]);
    int r = atoi(argv[3]);
    int R = atoi(argv[4]);

    vector<pair<int, int>> cands(R + 1);
    int y_up = R;
    int y_lo = R;
    for (int x = 0; x <= R; ++x) {
        while (x * int64_t(x) + y_up * int64_t(y_up) > R * int64_t(R))
            --y_up;

        y_lo = min(y_lo, y_up);
        while (y_lo > 0 and x * int64_t(x) + (y_up - 1) * int64_t(y_up - 1) >= r * int64_t(r))
            --y_lo;
        
        cands[x] = make_pair(y_lo, y_up);
    }

    vector<int64_t> psums(R + 2);
    psums[0] = 0;
    for (int i = 0; i <= R; ++i) {
        assert(cands[i].first <= cands[i].second);

        psums[i + 1] = psums[i] + cands[i].second - cands[i].first + 1;
    }

    set<pair<int, int>> pts;

    while (SZ(pts) < n) {
        int sx = rnd.next(0, 1) * 2 - 1;
        int sy = rnd.next(0, 1) * 2 - 1;

        int64_t val = rnd.next(psums.back());
        int ind = std::upper_bound(ALL(psums), val) - psums.begin() - 1;

        int x = sx * ind;
        int y = sy * (cands[ind].first + val - psums[ind]);

        pts.insert(make_pair(x, y));
    }

    cout << n << " " << k << "\n";
    for (auto elem: pts)
        cout << elem.first << " " << elem.second << "\n";
    
    return 0;
}
