#include <iostream>
#include <tuple>
#include <sstream>
#include <vector>
#include <cmath>
#include <ctime>
#include <bitset>
#include <cassert>
#include <cstdio>
#include <queue>
#include <set>
#include <map>
#include <fstream>
#include <cstdlib>
#include <string>
#include <cstring>
#include <algorithm>
#include <numeric>

#define mp make_pair
#define mt make_tuple
#define fi first
#define se second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define for1(i, n) for (int i = 1; i <= (int)(n); ++i)
#define ford(i, n) for (int i = (int)(n) - 1; i >= 0; --i)
#define fore(i, a, b) for (int i = (int)(a); i <= (int)(b); ++i)

using namespace std;

typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<pii> vpi;
typedef vector<vi> vvi;
typedef long long i64;
typedef vector<i64> vi64;
typedef vector<vi64> vvi64;
typedef pair<i64, i64> pi64;
typedef double ld;

template<class T> bool uin(T &a, T b) { return a > b ? (a = b, true) : false; }
template<class T> bool uax(T &a, T b) { return a < b ? (a = b, true) : false; }

struct TRes {
    pii a, b, c;

    TRes operator+(const TRes &r) const {
        return {max(a, r.a), min(b, r.b), max(c, r.c)};
    }
};

TRes NEUTRAL = {{-1e9, -1}, {1e9, -1}, {-1e9, -1}};

struct TNode {
    int L, R;
    int l, r;
    TRes res;
    int vala, valb, valc;
};

const int maxn = 210000;
TNode t[maxn];
int x[maxn], y[maxn];
int n, k;
int tc = 0;

#define dn TNode &n = t[node]

void relax(int node) {
    dn;
    n.res = t[n.l].res + t[n.r].res;
}

int buildTree(int L, int R) {
    int node = tc++;
    dn;
    n = {L, R, -1, -1, {{0, L}, {0, L}, {1, L}}, 0, 0, 0};
    if (R - L > 1) {
        int M = (L + R) / 2;
        n.l = buildTree(L, M);
        n.r = buildTree(M, R);
        relax(node);
    }
    return node;
}

void addval(int node, int a, int b, int c) {
    dn;
    if (a) {
        n.res.a.fi += a; 
        n.vala += a;
    }
    if (b) {
        n.res.b.fi += b;
        n.valb += b;
    }
    if (c) {
        n.res.c.fi += c;
        n.valc += c;
    }
}

void push(int node) {
    dn;
    addval(n.l, n.vala, n.valb, n.valc);
    addval(n.r, n.vala, n.valb, n.valc);
    n.vala = n.valb = n.valc = 0;
}

TRes query(int node, int L, int R) {
    dn;
    if (max(L, n.L) >= min(R, n.R)) return NEUTRAL;
    if (L <= n.L && n.R <= R) return n.res;
    push(node);
    return query(n.l, L, R) + query(n.r, L, R);
}

void change(int node, int L, int R, int da, int db, int dc) {
    dn;
    if (max(L, n.L) >= min(R, n.R)) return;
    if (L <= n.L && n.R <= R) {
        addval(node, da, db, dc);
        return;
    }
    push(node);
    change(n.l, L, R, da, db, dc);
    change(n.r, L, R, da, db, dc);
    if (da) n.res.a = max(t[n.l].res.a, t[n.r].res.a);
    if (db) n.res.b = min(t[n.l].res.b, t[n.r].res.b);
    if (dc) n.res.c = max(t[n.l].res.c, t[n.r].res.c);
//    relax(node);
}

void print(int node) {
    dn;
    if (n.R - n.L == 1) {
        cerr << n.L << ' ' << n.res.a.fi << ' ' << n.res.b.fi << ' ' << n.res.c.fi << '\n';
        return;
    }

    push(node);
    print(n.l);
    print(n.r);
}

int root;

void convert(int x) {
    while (1) {
        TRes res = query(root, 0, n);
//        cerr << res.a.fi << ' ' << res.a.se << ' ' << res.b.fi << ' ' << res.b.se << ' ' << res.c.fi << ' ' << res.c.se << '\n';
        bool any = false;
        if (res.a.fi >= k) {
            int p = res.a.se;
//            cerr << x << ' ' << p << ' ' << 1 << '\n';
            change(root, p, p + 1, -1e9, 0, 1);
            any = true;
        }
        if (res.b.fi < k) {
            int p = res.b.se;
//            cerr << x << ' ' << p << ' ' << 0 << '\n';
            change(root, p, p + 1, 0, 1e9, -1);
            any = true;
        }
        if (!any) break;
    }
}

set<pii> lh, mh, rh;
vi ordyx;

bool anyc(int M) {
    if (mh.empty()) return false;
    int L = mh.begin()->se;
    int R = (--mh.upper_bound(mp(mh.rbegin()->fi - M, 1e9)))->se;
//    cerr << "anyc " << L << ' ' << R << '\n';
    return query(root, L, R + 1).c.fi == 2;
}

void move_ex(set<pii> &a, set<pii> &b, bool fmin) {
    assert(!a.empty());
    pii x = fmin ? *a.begin() : *a.rbegin();
    a.erase(x);
    b.insert(x);
}

void normalize() {
    while (1) {
        if (lh.size() > k - 1) move_ex(lh, mh, false);
        else if (lh.size() < k - 1) {
            if (!mh.empty()) move_ex(mh, lh, true);
            else if (!rh.empty()) move_ex(rh, lh, true);
            else break;
        } else if (rh.size() > k - 1) move_ex(rh, mh, true);
        else if (rh.size() < k - 1) {
            if (!mh.empty()) move_ex(mh, rh, false);
            else break;
        } else break;
    }
}

void verify() {
    if (lh.size() < k - 1) assert(mh.empty() && rh.empty());
    else {
        assert(lh.size() == k - 1);
        if (rh.size() < k - 1) assert(lh.size() == k - 1 && mh.empty());
        else assert(rh.size() == k - 1);
    }
    if (!lh.empty() && !mh.empty()) assert(*lh.rbegin() <= *mh.begin());
    if (!mh.empty() && !rh.empty()) assert(*mh.rbegin() <= *rh.begin());
    if (mh.empty() && !lh.empty() && !rh.empty()) assert(*lh.rbegin() <= *rh.begin());
}

void insert(int p) {
    pii x = {y[ordyx[p]], p};
    if (lh.empty() || x <= *lh.rbegin()) lh.insert(x);
    else if (rh.empty() || x >= *rh.begin()) rh.insert(x);
    else mh.insert(x);
    normalize();
//    verify();
}

void erase(int p) {
    pii x = {y[ordyx[p]], p};
    lh.erase(x); mh.erase(x); rh.erase(x);
    normalize();
    verify();
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(10);
    cout << fixed;
#ifdef LOCAL_DEFINE
    freopen("input.txt", "rt", stdin);
#endif

    int T;
    T = 1;
    while (T--) {
        cin >> n >> k;
        forn(i, n) cin >> x[i] >> y[i];
        ordyx.resize(n);
        iota(all(ordyx), 0);
        sort(all(ordyx), [](int a, int b){return mp(y[a], x[a]) < mp(y[b], x[b]);});
        int L = 0, R = 2.1e6;
        while (R - L > 1) {
            int M = (L + R) / 2;
//            cerr << "M = " << M << '\n';
            vi r(n), l(n);
            int b = 0;
            forn(i, n) {
                while (b < n && y[ordyx[b]] < y[ordyx[i]] + M) ++b;
                r[i] = b;
            }

//            forn(i, n) cerr << r[i] << ' ';
//            cerr << '\n';

            int j = 0;
            forn(i, n) { 
                while (r[j] <= i) ++j;
                l[i] = j;
            }

//            forn(i, n) cerr << l[i] << ' ';
//            cerr << '\n';

            tc = 0;
            root = buildTree(0, n);
            change(root, 0, n, 0, n, 0);
            forn(i, n) change(root, l[i], i, 0, -1, 0);
            convert(-1e9);

            vector<tuple<int, int, int> > evs;
            forn(i, n) {
                evs.pb({x[ordyx[i]], 0, i});
                evs.pb({x[ordyx[i]] - M, 1, i});
            }
            sort(all(evs));

            lh.clear(); mh.clear(); rh.clear();
            forn(i, n) insert(i);
//                cerr << "lh: "; for (auto x: lh) cerr << x.se << ' '; cerr << '\n';
//                cerr << "mh: "; for (auto x: mh) cerr << x.se << ' '; cerr << '\n';
//                cerr << "rh: "; for (auto x: rh) cerr << x.se << ' '; cerr << '\n';
//            print(root);
            bool ok = anyc(M);
            for (auto w: evs) {
                if (ok) break;
                int X, t, i;
                tie(X, t, i) = w;
//                cerr << "ev " << X << ' ' << t << ' ' << i << '\n';
                if (t == 1) {
                    erase(i);
                    change(root, 0, n, 0, -1, 0);
                    change(root, l[i], i, 0, 1, 0);
                } else {
                    insert(i);
                    change(root, 0, n, 1, 0, 0);
                    change(root, l[i], i, -1, 0, 0);
                }
//                cerr << "lh: "; for (auto x: lh) cerr << x.se << ' '; cerr << '\n';
//                cerr << "mh: "; for (auto x: mh) cerr << x.se << ' '; cerr << '\n';
//                cerr << "rh: "; for (auto x: rh) cerr << x.se << ' '; cerr << '\n';
                convert(X);
//                print(root);
                ok |= anyc(M);
            }
            (ok ? L : R) = M;
        }
        cout << L << '\n';
    }        

#ifdef LOCAL_DEFINE
    cerr << "Time elapsed: " << 1.0 * clock() / CLOCKS_PER_SEC << " s.\n";
#endif
    return 0;
}
